#pragma once

class FFTDX10Helper
{
public:
	static bool CALLBACK IsDeviceAcceptable(
		UINT Adapter, UINT Output, D3D10_DRIVER_TYPE DeviceType,
		DXGI_FORMAT BufferFormat, bool bWindowed, void* pUserContext )
	{
		return reinterpret_cast<FFTDX10*>(pUserContext)
			->IsDeviceAcceptable(Adapter,Output,DeviceType,BufferFormat,bWindowed);
	}

	static HRESULT CALLBACK OnCreateDevice(
		ID3D10Device* pd3dDevice, const DXGI_SURFACE_DESC*
		in_pBufferSurfaceDesc, void* pUserContext )
	{
		return reinterpret_cast<FFTDX10*>(pUserContext)
			->OnCreateDevice(pd3dDevice, in_pBufferSurfaceDesc);
	}

	static bool CALLBACK ModifyDeviceSettings(
		DXUTDeviceSettings* pDeviceSettings, void* pUserContext)
	{
		return reinterpret_cast<FFTDX10*>(pUserContext)
			->ModifyDeviceSettings(pDeviceSettings);
	}

	static HRESULT CALLBACK OnResizedSwapChain(
		ID3D10Device* pd3dDevice, IDXGISwapChain *pSwapChain,
		const DXGI_SURFACE_DESC* in_pBufferSurfaceDesc, void* pUserContext )
	{
		return reinterpret_cast<FFTDX10*>(pUserContext)
			->OnSwapChainResized(pd3dDevice, pSwapChain, in_pBufferSurfaceDesc);
	}

	static void CALLBACK OnReleasingSwapChain( void* pUserContext )
	{
		reinterpret_cast<FFTDX10*>(pUserContext)->OnSwapChainReleasing();
	}


	static bool CALLBACK OnDeviceRemoved(void* pUserContext)
	{
		return reinterpret_cast<FFTDX10*>(pUserContext)->OnDeviceRemoved();
	}

	static void CALLBACK OnDestroyDevice( void* pUserContext )
	{
		reinterpret_cast<FFTDX10*>(pUserContext)->OnDestroyDevice();
	}


	// App Specific 
	static void CALLBACK OnFrameMove(
		double fTime, float fElapsedTime, void* pUserContext)
	{
		reinterpret_cast<FFTDX10*>(pUserContext)->OnFrameMove(fTime, fElapsedTime);
	}

	static void CALLBACK OnFrameRender(
		ID3D10Device* pd3dDevice,double fTime,float fElapsedTime,void* pUserContext)
	{
		return reinterpret_cast<FFTDX10*>(pUserContext)
			->OnFrameRender(pd3dDevice, fTime, fElapsedTime);
	}


	static LRESULT CALLBACK MsgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam,
		bool* pbNoFurtherProcessing, void* pUserContext )
	{
		return reinterpret_cast<FFTDX10*>(pUserContext)
			->MsgProc(hWnd, uMsg, wParam, lParam, pbNoFurtherProcessing);
	}



	// UI Events
	static void CALLBACK KeyboardProc(
		UINT nChar, bool bKeyDown, bool bAltDown, void* pUserContext )
	{
		reinterpret_cast<FFTDX10*>(pUserContext)->KeyboardProc( nChar, bKeyDown, bAltDown );
	}

};

